diff -ur stunnel-4.16/src/resolver.c stunnel-4.16-roundrobin/src/resolver.c
--- stunnel-4.16/src/resolver.c	2006-01-08 00:49:08.000000000 +1100
+++ stunnel-4.16-roundrobin/src/resolver.c	2007-01-08 12:31:55.481342964 +1100
@@ -82,6 +82,24 @@
 #endif
 
 int name2addrlist(SOCKADDR_LIST *addr_list, char *name, char *default_host) {
+    char tmp[STRLEN], *p, *comma;
+    int num_addrs=0, name_len;
+    p=name;
+    while((comma=strchr(p, ','))) {
+        name_len=comma-p;
+        if (name_len>=STRLEN)
+            name_len=STRLEN-1;
+        memcpy(tmp,p,name_len);
+        tmp[name_len]='\0';
+        num_addrs += singlename2addrlist(addr_list, tmp, default_host);
+        p = comma+1;
+    }
+    num_addrs += singlename2addrlist(addr_list, p, default_host);
+    return num_addrs;
+}
+
+static int singlename2addrlist(SOCKADDR_LIST *addr_list, char *name,
+        char *default_host) {
     char tmp[STRLEN], *hostname, *portname;
 
     /* set hostname and portname */
